#include <stdio.h>
#include <stdlib.h>
#include <roxml.h>
#include "ClassesXML.h"
#include "structures.h"


Classe** Remplir_Classes(const char *filename)   // Remplit le tableau de classes  partir du fichier XML
{


    node_t *root, *Classes;
    unsigned int i=0, nb_classes=0;

    char PV_text; /* a supprimer */

    root = roxml_load_doc(filename);            /* Ouvre le doc XML et cr le noeud de base */
    Classes = roxml_get_chld(root, NULL, 0);    /* Descend d'un niveau dans l'arborescence */
    nb_classes = roxml_get_chld_nb(Classes);    /* Rcupre le nombre de classes entres dans le fichier XML */
    printf("Classes contient %d enfants\n", nb_classes);



    printf("Chargement des classes\n");
    Classe** ListeClasse = malloc(nb_classes * sizeof(Classe));

    for(i=0; i<nb_classes; i++)   /* Boucle de remplissage des classes */
    {
    Classe Classe_en_cours;
    node_t *Classe;
    char *id_text, *name_text, *PV_text, *PM_text, *MV_text, *DESC_text;
    int Pv_max, mana_max, points_deplacement_max;

    Classe = roxml_get_chld(Classes, NULL, i);

    node_t *Skills, *ID, *NAME, *PV, *PM, *MV, *DESC;

    ID = roxml_get_attr(Classe, "id", 0);
    NAME = roxml_get_attr(Classe, "name", 0);
    PV = roxml_get_attr(Classe, "PV", 0);
    PM = roxml_get_attr(Classe, "PM", 0);
    MV = roxml_get_attr(Classe, "MV", 0);
    DESC = roxml_get_attr(Classe, "Desc", 0);

    id_text = roxml_get_content(ID, NULL, 0, NULL);
    name_text = roxml_get_content(NAME, NULL, 0, NULL);
    PV_text = roxml_get_content(PV, NULL, 0, NULL);
    PM_text = roxml_get_content(PM, NULL, 0, NULL);
    MV_text = roxml_get_content(MV, NULL, 0, NULL);
    DESC_text = roxml_get_content(DESC, NULL, 0, NULL);
/*
    printf("L'id est : %s\n", id_text);
    printf("Le nom est : %s\n", name_text);
    printf("Le nombre de PV est : %s\n", PV_text);
    printf("Le nombre de PM est : %s\n", PM_text);
    printf("Le nombre MV est : %s\n", MV_text);
    printf("La description est : %s\n", DESC_text);
*/

    /* Convertion des caractristiques lues vers les types de la struct Classe */
    Pv_max = atoi(PV_text);
    mana_max = atoi(PM_text);
    points_deplacement_max = atoi(MV_text);


    /* Remplissage des caractristiques de la classe en cours */
    Classe_en_cours.PV_max=Pv_max;
    Classe_en_cours.mana_max=mana_max;
    Classe_en_cours.points_deplacement_max=points_deplacement_max;


    /* Ajout de la classe remplie au tableau */

    }

roxml_free_node(Classes);

return ListeClasse;

}

